VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cDateTime"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Annees As Long, Mois As Long, Jours As Long
Public Heures As Long, Minutes As Long

Public Function Add(Minutes As Long, _
                    Optional Heures As Long = 0, _
                    Optional Jours As Long = 0, _
                    Optional Mois As Long = 0, _
                    Optional Annees As Long = 0) As cDateTime
Dim aDateTime As cDateTime, calc As Variant

   Set aDateTime = New cDateTime
   aDateTime.AddTo Minutes, Heures, Jours, Mois, Annees
   Set Add = aDateTime
   Set aDateTime = Nothing

End Function

Public Sub AddTo(Minutes As Long, _
                    Optional Heures As Long = 0, _
                    Optional Jours As Long = 0, _
                    Optional Mois As Long = 0, _
                    Optional Annees As Long = 0)
Dim calc As Variant

   calc = DateSerial(Me.Annees, Me.Mois, Me.Jours) & " " & TimeSerial(Me.Heures, Me.Minutes, 0)

   calc = DateAdd("n", Minutes, calc)
   calc = DateAdd("h", Heures, calc)
   calc = DateAdd("d", Jours, calc)
   calc = DateAdd("m", Mois, calc)
   calc = DateAdd("yyyy", Annees, calc)

   With Me
      .Annees = Year(calc)
      .Mois = Month(calc)
      .Jours = Day(calc)
      .Heures = Hour(calc)
      .Minutes = Minute(calc)
   End With

End Sub

Public Sub SetToday()
Dim calc As Variant
   calc = Now
   With Me
      .Annees = Year(calc)
      .Mois = Month(calc)
      .Jours = Day(calc)
      .Heures = Hour(calc)
      .Minutes = Minute(calc)
   End With
End Sub

Public Sub LoadFrom(serialized As String)
   With Me
      .Annees = Year(serialized)
      .Mois = Month(serialized)
      .Jours = Day(serialized)
      .Heures = Hour(serialized)
      .Minutes = Minute(serialized)
   End With
End Sub

Public Function PrintOn() As String
   PrintOn = CStr(Me.Annees) & "/" & LeadingZeroes(2, CStr(Me.Mois)) & "/" & _
             LeadingZeroes(2, CStr(Me.Jours)) & " " & LeadingZeroes(2, CStr(Me.Heures)) & _
             ":" & LeadingZeroes(2, CStr(Me.Minutes)) & ":00"
End Function

Public Function IsEqualTo(aDateTime As cDateTime) As Boolean
   IsEqualTo = (Me.Annees = aDateTime.Annees) And _
               (Me.Mois = aDateTime.Mois) And _
               (Me.Jours = aDateTime.Jours) And _
               (Me.Heures = aDateTime.Heures) And _
               (Me.Minutes = aDateTime.Minutes)
End Function

Public Function IsGreaterThan(aDateTime As cDateTime) As Boolean

   IsGreaterThan = False
   If Me.Annees > aDateTime.Annees Then
      IsGreaterThan = True
   ElseIf Me.Annees = aDateTime.Annees Then
      If Me.Mois > aDateTime.Mois Then
         IsGreaterThan = True
      ElseIf Me.Mois = aDateTime.Mois Then
         If Me.Jours > aDateTime.Jours Then
            IsGreaterThan = True
         ElseIf Me.Jours = aDateTime.Jours Then
            If Me.Heures > aDateTime.Heures Then
               IsGreaterThan = True
            ElseIf Me.Heures = aDateTime.Heures Then
               IsGreaterThan = (Me.Minutes > aDateTime.Minutes)
            End If
         End If
      End If
   End If
      
End Function
