Attribute VB_Name = "winApi"
Option Explicit

Public Enum eMouseEvent
   MOUSEEVENTF_MOVE = &H1&           ' /* mouse move */
   MOUSEEVENTF_LEFTDOWN = &H2&       ' /* left button down */
   MOUSEEVENTF_LEFTUP = &H4&         ' /* left button up */
   MOUSEEVENTF_RIGHTDOWN = &H8&      ' /* right button down */
   MOUSEEVENTF_RIGHTUP = &H10&       ' /* right button up */
   MOUSEEVENTF_MIDDLEDOWN = &H20&    ' /* middle button down */
   MOUSEEVENTF_MIDDLEUP = &H40&      ' /* middle button up */
   MOUSEEVENTF_WHEEL = &H800&        ' /* wheel button rolled */
   MOUSEEVENTF_ABSOLUTE = &H8000&    ' /* absolute move */
End Enum

Public Declare Function SystemParametersInfo Lib "user32" Alias "SystemParametersInfoA" _
   (ByVal uAction As Long, ByVal uParam As Long, ByRef lpvParam As Any, ByVal fuWinIni As Long) As Long

Public Declare Sub mouse_event Lib "user32" _
  (ByVal dwFlags As eMouseEvent, ByVal dx As Long, ByVal dy As Long, _
   ByVal cButtons As Long, ByVal dwExtraInfo As Long)

Public Declare Function SetMessageExtraInfo Lib "user32" (ByVal lParam As Long) As Long

Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" _
   (pDest As Any, pSrc As Any, ByVal ByteLen As Long)

Const MSH_MOUSEWHEEL = "MSWHEEL_ROLLMSG"
Const WHEEL_DELTA = 120
Global Const BSF_POSTMESSAGE = &H10&
Global Const BSM_APPLICATIONS = &H8&

Public Type POINTAPI
   x As Long
   y As Long
End Type

Public Enum EHTMousewParamValues
   WM_MOUSEMOVE = 512
   WM_LBUTTONDBLCLK = 515
   WM_LBUTTONDOWN = 513
   WM_LBUTTONUP = 514
   WM_MBUTTONDBLCLK = 521
   WM_MBUTTONDOWN = 519
   WM_MBUTTONUP = 520
   WM_RBUTTONDBLCLK = 518
   WM_RBUTTONUP = 517
   WM_RBUTTONDOWN = 516
   WM_NCLBUTTONDBLCLK = &HA3
   WM_NCLBUTTONDOWN = &HA1
   WM_NCLBUTTONUP = &HA2
   WM_NCMBUTTONDBLCLK = &HA9
   WM_NCMBUTTONDOWN = &HA7
   WM_NCMBUTTONUP = &HA8
   WM_NCMOUSEMOVE = &HA0
   WM_NCRBUTTONDBLCLK = &HA6
   WM_NCRBUTTONDOWN = &HA4
   WM_NCRBUTTONUP = &HA5
   WM_MOUSEWHEEL = 522
End Enum

Public Type WheelStruct
   Unknown1 As Long
   Unknown2 As Long
   Unknown3 As Long
   Unknown4 As Long
   Unknown5 As Long
   WheelRotation As Integer
   Unknown6 As Integer
End Type

Public Type MOUSEHOOKSTRUCT '{ // ms
    pt As POINTAPI
    hwnd As Long
    wHitTestCode As Long
    dwExtraInfoLow As Integer
    dwExtraInfoHigh As Integer
End Type

Public Type Msg '{     /* msg */
   hwnd As Long     '\\ The window whose Winproc will receive the message
   Message As Long  '\\ The message number
   wParam As Long
   lParam As Long
   time As Long     '\\ The time the message was posted
   pt As POINTAPI   '\\ The cursor position in screen coordinates
                    '\\  of the message
End Type
